scriptname ArcaneCleanserScript extends ObjectReference

; Armor types
Keyword property ArmorCuirass_Keyword auto
FormList property ArmorCuirasses_Enchanted auto
FormList property ArmorCuirasses_Cleansed auto
Keyword property ArmorBoots_Keyword auto
FormList property ArmorBoots_Enchanted auto
FormList property ArmorBoots_Cleansed auto
Keyword property ArmorGauntlets_Keyword auto
FormList property ArmorGauntlets_Enchanted auto
FormList property ArmorGauntlets_Cleansed auto
Keyword property ArmorHelmet_Keyword auto
FormList property ArmorHelmets_Enchanted auto
FormList property ArmorHelmets_Cleansed auto
Keyword property ArmorShield_Keyword auto
FormList property ArmorShields_Enchanted auto
FormList property ArmorShields_Cleansed auto

; Clothing types
Keyword property ClothingBody_Keyword auto
FormList property ClothingBodies_Enchanted auto
FormList property ClothingBodies_Cleansed auto
Keyword property ClothingFeet_Keyword auto
FormList property ClothingFeet_Enchanted auto
FormList property ClothingFeet_Cleansed auto
Keyword property ClothingHands_Keyword auto
FormList property ClothingHands_Enchanted auto
FormList property ClothingHands_Cleansed auto
Keyword property ClothingHead_Keyword auto
FormList property ClothingHeads_Enchanted auto
FormList property ClothingHeads_Cleansed auto
Keyword property ClothingCirclet_Keyword auto
FormList property ClothingCirclets_Enchanted auto
FormList property ClothingCirclets_Cleansed auto

; Jewelry
Keyword property ArmorJewelry_Keyword auto
FormList property ArmorJewelry_Enchanted auto
FormList property ArmorJewelry_Cleansed auto

; Weapon types
Keyword property Battleaxe_Keyword auto
FormList property Battleaxes_Enchanted auto
FormList property Battleaxes_Cleansed auto
Keyword property Bow_Keyword auto
FormList property Bows_Enchanted auto
FormList property Bows_Cleansed auto
Keyword property Dagger_Keyword auto
FormList property Daggers_Enchanted auto
FormList property Daggers_Cleansed auto
Keyword property Greatsword_Keyword auto
FormList property Greatswords_Enchanted auto
FormList property Greatswords_Cleansed auto
Keyword property Mace_Keyword auto
FormList property Maces_Enchanted auto
FormList property Maces_Cleansed auto
Keyword property Staff_Keyword auto
FormList property Staffs_Enchanted auto
FormList property Staffs_Cleansed auto
Keyword property Sword_Keyword auto
FormList property Swords_Enchanted auto
FormList property Swords_Cleansed auto
Keyword property WarAxe_Keyword auto
FormList property WarAxes_Enchanted auto
FormList property WarAxes_Cleansed auto
Keyword property Warhammer_Keyword auto
FormList property Warhammers_Enchanted auto
FormList property Warhammers_Cleansed auto

; Other
FormList property Other_Enchanted auto
FormList property Other_Cleansed auto

Actor property PlayerRef auto

Message property ConfirmationDialog auto

GlobalVariable property ConfirmationEnabled auto
GlobalVariable property CleansingCostEnabled auto

Form function AttemptCleanse(Form baseItem, FormList enchanted, FormList cleansed)
	int i = enchanted.GetSize()
	while i > 0
		i -= 1
		
		Form f = enchanted.GetAt(i)
		FormList fl = f as FormList
		
		if (fl) ; Form is a sublist (generic enchanted item)
			if (fl.Find(baseItem) != -1)
				; Found item (generic enchanted item)
				return cleansed.GetAt(i)
			endif
		elseif (f == baseItem)
			; Found item (artifact or unique)
			return cleansed.GetAt(i)
		endif
	endwhile
	
	return none
endfunction

Form function GetCleansedItem(Form akBaseItem)
	Form cleansedItem = none
	
	; Armors
	if akBaseItem.HasKeyword(ArmorCuirass_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, ArmorCuirasses_Enchanted, ArmorCuirasses_Cleansed)
	elseif akBaseItem.HasKeyword(ArmorBoots_Keyword)
		CleansedItem = AttemptCleanse(akBaseItem, ArmorBoots_Enchanted, ArmorBoots_Cleansed)
	elseif akBaseItem.HasKeyword(ArmorGauntlets_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, ArmorGauntlets_Enchanted, ArmorGauntlets_Cleansed)
	elseif akBaseItem.HasKeyword(ArmorHelmet_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, ArmorHelmets_Enchanted, ArmorHelmets_Cleansed)
	elseif akBaseItem.HasKeyword(ArmorShield_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, ArmorShields_Enchanted, ArmorShields_Cleansed)
	; Clothing
	elseif akBaseItem.HasKeyword(ClothingBody_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, ClothingBodies_Enchanted, ClothingBodies_Cleansed)
	elseif akBaseItem.HasKeyword(ClothingFeet_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, ClothingFeet_Enchanted, ClothingFeet_Cleansed)
	elseif akBaseItem.HasKeyword(ClothingHands_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, ClothingHands_Enchanted, ClothingHands_Cleansed)
	elseif akBaseItem.HasKeyword(ClothingHead_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, ClothingHeads_Enchanted, ClothingHeads_Cleansed)
	elseif akBaseItem.HasKeyword(ClothingCirclet_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, ClothingCirclets_Enchanted, ClothingCirclets_Cleansed)
	; Jewelry
	elseif akBaseItem.HasKeyword(ArmorJewelry_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, ArmorJewelry_Enchanted, ArmorJewelry_Cleansed)
	; Weapons
	elseif akBaseItem.HasKeyword(Battleaxe_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, Battleaxes_Enchanted, Battleaxes_Cleansed)
	elseif akBaseItem.HasKeyword(Bow_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, Bows_Enchanted, Bows_Cleansed)
	elseif akBaseItem.HasKeyword(Dagger_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, Daggers_Enchanted, Daggers_Cleansed)
	elseif akBaseItem.HasKeyword(Greatsword_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, Greatswords_Enchanted, Greatswords_Cleansed)
	elseif akBaseItem.HasKeyword(Mace_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, Maces_Enchanted, Maces_Cleansed)
	elseif akBaseItem.HasKeyword(Staff_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, Staffs_Enchanted, Staffs_Cleansed)
	elseif akBaseItem.HasKeyword(Sword_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, Swords_Enchanted, Swords_Cleansed)
	elseif akBaseItem.HasKeyword(WarAxe_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, WarAxes_Enchanted, WarAxes_Cleansed)
	elseif akBaseItem.HasKeyword(Warhammer_Keyword)
		cleansedItem = AttemptCleanse(akBaseItem, Warhammers_Enchanted, Warhammers_Cleansed)
	else
	; Other
		cleansedItem = AttemptCleanse(akBaseItem, Other_Enchanted, Other_Cleansed)
	endif
	
	if (cleansedItem)
		return cleansedItem
	endif
	
	return akBaseItem
endfunction

event OnInit()
	SetActorOwner(PlayerRef.GetActorBase())
endevent

event OnItemAdded(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akSourceContainer)
	if (akSourceContainer != PlayerRef)
		return
	endif

	 ; Return the item to the player immediately if it's not a weapon or armor
	if ((!(akBaseItem as Armor) && !(akBaseItem as Weapon)) || (ConfirmationEnabled.GetValueInt() && ConfirmationDialog.Show() == 1))
		RemoveItem(akBaseItem, aiItemCount, true, akSourceContainer)
	else	
		DropObject(akBaseItem, aiItemCount)
	endif
endevent

event OnItemRemoved(Form akBaseItem, int aiItemCount, ObjectReference akItemReference, ObjectReference akDestContainer)
	if (akItemReference)
		ActorBase actorOwner = akItemReference.GetActorOwner()
		Faction	factionOwner = akItemReference.GetFactionOwner()
		float itemHealth = akItemReference.GetItemHealthPercent()
		akItemReference.Delete()
		
		Form cleansedItem = GetCleansedItem(akBaseItem)
		
		ObjectReference newItemRef = PlaceAtMe(cleansedItem, aiItemCount)
		if (actorOwner)
			newItemRef.SetActorOwner(actorOwner)
		elseif (factionOwner)
			newItemRef.SetFactionOwner(factionOwner)
		endif
		newItemRef.SetItemHealthPercent(itemHealth) ; SKSE
		
		PlayerRef.AddItem(newItemRef, aiItemCount)
	endif
endevent